// Copyright (c) 2024 FWORKS. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
#include "SuperSimpleFSMComponent.h"
#include "Engine/TimerHandle.h"
#include "SeasonsFSMComponent.generated.h"

UCLASS(ClassGroup = (Custom), meta = (BlueprintSpawnableComponent), Blueprintable)
class SUPERSIMPLEFSM_API USeasonsFSMComponent : public USuperSimpleFSMComponent
{
	GENERATED_BODY()

public:	
	// Sets default values for this component's properties
	USeasonsFSMComponent();

	virtual void OnRegisterStateCallbacks_Implementation() override;

    UFUNCTION()
    void Spring_Begin(FGameplayTag StateTag);

    UFUNCTION()
    void SummerRainy_Begin(FGameplayTag StateTag);

    UFUNCTION()
    void SummerDrought_Begin(FGameplayTag StateTag);

    UFUNCTION()
    void Autumn_Begin(FGameplayTag StateTag);

    UFUNCTION()
    void Winter_Begin(FGameplayTag StateTag);

    UFUNCTION()
    void WinterSnowy_Begin(FGameplayTag StateTag);

    UFUNCTION()
    void WinterDry_Begin(FGameplayTag StateTag);

    UFUNCTION()
    void Winter_Tick(FGameplayTag StateTag, float DeltaTime);

private:
    void PrintStateDebug(FString DebugText);
    FTimerHandle TimerHandle;
    float TickTimer = 0.0f;
};
